<template>
    <main>
        <div v-if="!persons" class="loading">
            <v-icon left class="loading">fas fa-spinner fa-spin</v-icon>
            Loading...
        </div>

        <v-card>
            <v-card-title>
                Person List
                <v-btn @click.prevent="viewPerson('new')" color="success" small class="ml-4">
                    <v-icon left>fas fa-plus</v-icon> Create
                </v-btn>
                <v-spacer></v-spacer>
                <v-text-field
                        v-model="searchPhrase"
                        append-icon="mdi-magnify"
                        label="Search"
                        single-line
                        hide-details
                ></v-text-field>
            </v-card-title>
            <v-data-table
                    :headers="tblHeaders"
                    :items="persons"
                    :items-per-page="10"
                    class="elevation-1"
                    dense
                    :loading="persons === undefined"
                    loading-text="Loading persons from db, hang tight"
                    :search="searchPhrase"
                    :footer-props="{
                        showFirstLastPage: true,
                        itemsPerPageOptions: [10, 20, 50, 100, -1]
                    }"
                    @click:row="rowClicked"
            >
                <template v-slot:item.female="{ item }">
                    <v-simple-checkbox v-model="item.female" disabled></v-simple-checkbox>
                </template>
                <template v-slot:item.actions="{ item }">
                    <v-icon small class="mr-2" @click="viewPerson(item.id)" color="primary" title="View this object">
                        fas fa-edit
                    </v-icon>
                    <v-icon small @click="deletePerson(item.id)" color="red" class="ml-3" title="Delete from database">
                        fas fa-trash-alt
                    </v-icon>
                </template>
            </v-data-table>
        </v-card>
    </main>
</template>

<script>
    import axios from 'axios';
    const baseUrl = 'http://localhost:8000/api/v1';

    export default {
        name: 'person-list.page',

        data() {
            return {
                persons: undefined,
                tblHeaders: [
                    {text: 'Primary Key', value: 'id', sortable: true},
                    {text: 'Name', value: 'name', sortable: true},
                    {text: 'Age', value: 'age', sortable: true},
                    {text: 'Post Code', value: 'postCode', sortable: true},
                    {text: 'Is Female', value: 'female', sortable: true},
                    {text: 'Actions', value: 'actions', sortable: false}
                ],
                searchPhrase: ''
            };
        },

        mounted() {
            this.load();
        },

        methods: {
            load: async function () {
                const url    = `${baseUrl}/person`;
                const result = await axios.get(url);
                this.persons = result.data;
            },

            rowClicked: function(item){
                this.viewPerson(item.id);
            },

            viewPerson: async function (id) {
                this.$router.push(`/person-view/${id}`)
            },

            deletePerson: async function (id) {
                const url    = `${baseUrl}/person/${id}`;
                await axios.delete(url);
                const idx = this.persons.findIndex(p => p.id === id);
                this.persons.splice(idx, 1);
            }
        }
    }
</script>

<style scoped lang="scss">
    .loading {
        color: darkorange;
        font-size: 2rem;
    }
</style>
